using System;
using System.Linq;
using JLHHJSvr.BLL;
using JLHHJSvr.Com;
using JLHHJSvr.Helper;
using JLHHJSvr.LJException;
using LJLib.DAL.SQL;
using LJLib.Net.SPI.Server;
using LJLib.SQLEX;

namespace JLHHJSvr.Excutor
{
    internal sealed class DeleteSoftBedQuoteExcutor : ExcutorBase<DeleteSoftBedQuoteRequest, DeleteSoftBedQuoteResponse>
    {
        protected override void ExcuteInternal(DeleteSoftBedQuoteRequest request, object state, DeleteSoftBedQuoteResponse rslt)
        {
            var tokendata = BllHelper.GetToken(request.token);
            if (!request.list.Any())
            {
                rslt.ErrMsg = "至少提交一条需要删除的记录";
                return;
            }

            using (var con = GlobalVar.ConnectionString.NewSqlConnection())
            using (var cmd = con.CreateCommand())
            {
                con.Open();

                var softBedHelper = HelperBase.GetHelper<SoftBedHelper>(cmd,new HelperBase.Context() { tokendata = tokendata });

                using (cmd.Transaction = con.BeginTransaction())
                {
                    try
                    {
                        foreach(var mx in request.list)
                        {
                            softBedHelper.DeleteSoftBed(mx.softbed_id);
                        }

                        cmd.Transaction.Commit();
                    }
                    catch (Exception e)
                    {
                        cmd.Transaction?.Rollback();
                        rslt.ErrMsg = e.Message;
                    }
                }
            }
        }
    }
}
